#pragma semicolon 1

#include <sourcemod>
#include <vip>

native HM_MD5(const String:str[], String:result[]);

public Plugin:myinfo = 
{
	name	= "VIP [Steam Protect]",
	author	= "wS",
	version = "1.0.5"
};

#define MD5_SALT			"meow"
#define ITEM_NAME			"steam_protect"

new Handle:g_hSQL			= INVALID_HANDLE;
new g_ItemID;

#define NEED_QUERY			0
#define QUERY_NOT_COMPLITED	1
#define NOT_PROTECTED		2
#define PROTECTED			3

// 0 = need query
// 1 = query started, but not completed, or completed with error
// 2 = steam not protected (not found in db)
// 3 = steam protected (exist in db)
new g_Protect[MAXPLAYERS + 1]; 

public OnPluginStart()
{
	if (!(g_ItemID = VIP_RegisterItem(ITEM_NAME, VIP_ITEM_SELECT)))
		SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME);
	
	LoadTranslations("vip_steam_protect.phrases");
	
	VIP_HookEvent(VE_Sql,					VIP_SQL);
	RegConsoleCmd("sm_vipsteamprotect",		SteamProtectCmd);
	RegAdminCmd("sm_vipsteamprotect_remove",sm_vipsteamprotect_remove_or_find, ADMFLAG_ROOT);
	RegAdminCmd("sm_vipsteamprotect_find",	sm_vipsteamprotect_remove_or_find, ADMFLAG_ROOT);
	if ((g_hSQL = VIP_GetSqlHandle()))		CreateTable();
}

public VIP_SQL(Handle:hSQL)
{
	if ((g_hSQL = hSQL))
		CreateTable();
}

stock CreateTable()
{
	SQL_TQuery(g_hSQL, SQL_CallBack, "CREATE TABLE IF NOT EXISTS `vip_steam_protect_tab` (`steamid` VARCHAR(32), `email` VARCHAR(150), `vip_login` VARCHAR(33), `vip_pass` VARCHAR(33), PRIMARY KEY (`steamid`))", _, DBPrio_High);
	
	for (new i = 1; i <= MaxClients; i++)
	{
		g_Protect[i] = NEED_QUERY;
		if (IsClientInGame(i)) OnClientPutInServer(i);
	}
}

public SQL_CallBack(Handle:hSQL, Handle:hResult, const String:sError[], any:data)
{
	if (!hResult)
		LogError(sError);
}

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	if (g_Protect[client] == PROTECTED)
	{
		IntToString(1, ItemValue, ItemValueSize);
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

///////////////////////////////////////////////////////////////////////////////////

public OnClientDisconnect(client)
	g_Protect[client] = NEED_QUERY;

public OnClientPutInServer(client)
{
	if (g_hSQL && !IsFakeClient(client))
	{
		decl String:steamid[STEAMID_LENGTH];
		if (GetClientAuthId(client, AuthId_Steam2, steamid, sizeof(steamid)))
		{
			decl String:sQuery[200];
			FormatEx(sQuery,		sizeof(sQuery), "SELECT `vip_login`, `vip_pass` FROM `vip_steam_protect_tab` WHERE `steamid` = '%s' LIMIT 1", steamid);
			new Handle:hPack		= CreateDataPack();
			WritePackCell(hPack,	GetClientUserId(client));
			WritePackString(hPack,	steamid);
			g_Protect[client]		= QUERY_NOT_COMPLITED;
			SQL_TQuery(g_hSQL,		SQL_CheckLoginAndPass, sQuery, hPack, DBPrio_High);
		}
	}
}

public SQL_CheckLoginAndPass(Handle:hSQL, Handle:hResult, const String:sError[], any:hPack)
{
	ResetPack(hPack);
	new client = GetClientOfUserId(ReadPackCell(hPack));
	decl String:steamid[STEAMID_LENGTH];
	ReadPackString(hPack, steamid, sizeof(steamid));
	CloseHandle(hPack);

	if (client < 1 || IsClientInKickQueue(client))
		return;

	if (!hResult)
	{
		LogError(sError);
		PrintToChat(client, sError);
		return;
	}

	if (!SQL_FetchRow(hResult))
	{
		g_Protect[client] = NOT_PROTECTED;
		return;
	}
	
	g_Protect[client] = PROTECTED;

	decl String:db_login[33], String:client_pass[33];
	SQL_FetchString(hResult, 0, db_login, sizeof(db_login));
	
	if (GetClientInfo(client, db_login, client_pass, sizeof(client_pass)))
	{
		decl String:db_pass[33];
		SQL_FetchString(hResult, 1, db_pass, sizeof(db_pass));
		
		ConvertPassToMd5(client_pass, steamid, client_pass);

		if (!strcmp(client_pass, db_pass, true))
			return;
	}
	
	KickClient(client, "%t", "kick_msg", steamid);
}

//

public Action:sm_vipsteamprotect_remove_or_find(admin, args)
{
	if (!SqlOn(admin))
		return Plugin_Handled;
	
	decl String:cmd[30];
	GetCmdArg(0, cmd, sizeof(cmd));
	
	if (args < 1)
	{
		PrintToConsole(admin, "%s \"steamid or email or login\"", cmd);
		return Plugin_Handled;
	}
	
	decl String:key[150];
	GetCmdArgString(key, sizeof(key));
	TrimString(key);
	StripQuotes(key);
	if (strlen(key) < 5)
		return Plugin_Handled;
	
	decl String:sInfo[512];
	if (cmd[19] == 'r')
	{
		FormatEx(sInfo, sizeof(sInfo), "DELETE FROM `vip_steam_protect_tab` WHERE `steamid` = '%s' OR `email` = '%s' OR `vip_login` = '%s'", key, key, key);
		SQL_TQuery(g_hSQL, SQL_Remove, sInfo, admin > 0 ? GetClientUserId(admin) : 0, DBPrio_High);
		
		if (StrContains(key, "STEAM_", false) == 0)
		{
			decl String:steamid[STEAMID_LENGTH];
			for (new i = 1; i <= MaxClients; i++)
			{
				if (IsClientInGame(i) && !IsFakeClient(i) && GetClientAuthId(i, AuthId_Steam2, steamid, sizeof(steamid)) && !strcmp(steamid, key, false))
				{
					g_Protect[i] = NOT_PROTECTED;
					break;
				}
			}
		}
	}
	else
	{
		FormatEx(sInfo, sizeof(sInfo), "SELECT `steamid`, `email`, `vip_login` FROM `vip_steam_protect_tab` WHERE `steamid` = '%s' OR `email` = '%s' OR `vip_login` = '%s'", key, key, key);
		SQL_TQuery(g_hSQL, SQL_Select, sInfo, admin > 0 ? GetClientUserId(admin) : 0, DBPrio_High);
	}

	return Plugin_Handled;
}

public SQL_Remove(Handle:hSQL, Handle:hResult, const String:sError[], any:admin)
{
	if (admin > 0 && (admin = GetClientOfUserId(admin)) < 1)
		admin = 0;

	if (!hResult)
	{
		LogError(sError);
		PrintToConsole(admin, sError);
		return;
	}

	new count = SQL_GetAffectedRows(hResult);
	PrintToConsole(admin, "removed: %d", count);
	if (admin < 1) LogToGame("removed: %d", count);
}

public SQL_Select(Handle:hSQL, Handle:hResult, const String:sError[], any:admin)
{
	if (admin > 0 && (admin = GetClientOfUserId(admin)) < 1)
		admin = 0;

	if (!hResult)
	{
		LogError(sError);
		PrintToConsole(admin, sError);
		return;
	}

	new count = 0;
	decl String:steamid[STEAMID_LENGTH], String:email[150], String:login[33];
	
	while (SQL_FetchRow(hResult))
	{
		++count;
		
		SQL_FetchString(hResult, 0, steamid, sizeof(steamid));
		SQL_FetchString(hResult, 1, email,	 sizeof(email));
		SQL_FetchString(hResult, 2, login,	 sizeof(login));
		
		PrintToConsole(admin, "%02d. %s, %s (login: %s)", count, steamid, email, login);
		if (admin < 1) LogToGame("%02d. %s, %s (login: %s)", count, steamid, email, login);
	}
	
	if (!count)
	{
		PrintToConsole(admin, "not found");
		if (admin < 1) LogToGame("not found");
	}
}

//

public VIP_MenuSelect(client, ItemID, const String:ItemName[], const String:ItemValue[])
{
	ProtectMenu(client);
}

stock ProtectMenu(client)
{
	new Handle:panel = CreatePanel();
	
	decl String:text[512];
	FormatEx(text, sizeof(text), "%T\n \n", "title", client);
	SetPanelTitle(panel, text);

	if (g_Protect[client] == QUERY_NOT_COMPLITED)
	{
		FormatEx(text, sizeof(text), "%T", "wait", client);
		DrawPanelText(panel, text);
	}
	else if (g_Protect[client] == PROTECTED)
	{
		FormatEx(text, sizeof(text), "%T", "protect_on", client);
		DrawPanelText(panel, text);
	}
	else
	{
		FormatEx(text, sizeof(text), "%T", "protect_info", client);
		DrawPanelText(panel, text);
	}
	
	DrawPanelText(panel, " ");
	
	SetPanelCurrentKey(panel, 8);
	DrawPanelItem(panel, "<-");
	SetPanelCurrentKey(panel, GetEngineVersion() == Engine_CSGO ? 9 : 10);
	FormatEx(text, sizeof(text), "%T", "exit", client);
	DrawPanelItem(panel, text);
	
	SendPanelToClient(panel, client, ProtectMenu_CallBack, 0);
	CloseHandle(panel);
}

public ProtectMenu_CallBack(Handle:panel, MenuAction:action, client, item)
{
	if (action == MenuAction_Select)
	{
		if (item == 8)
		{
			if (!VIP_MenuFlood(client))
			{
				PLAY_EXIT_BACK_SOUND(client);
				VIP_ShowMenu(client);
			}
		}
		else
			PLAY_EXIT_SOUND(client);
	}
}

// Доступ к команде:
// 1. Если он по админскому флагу
// 2. Если это VIP игрок и VIP выдан не функцией "Бесплатный VIP в определенное время"
	
public Action:SteamProtectCmd(client, x)
{
	if (client < 1 || client > MaxClients || !SqlOn(client))
		return Plugin_Handled;
	
	if (x < 1)
	{
		PrintToConsole(client, "sm_vipsteamprotect \"email\"");
		return Plugin_Handled;
	}

	if (g_Protect[client] != NOT_PROTECTED)
	{
		PrintToConsole(client, "%t", g_Protect[client] == PROTECTED ? "protect_on" : "wait");
		return Plugin_Handled;
	}
	
	new bool:bAccessByFlag;
	if (!VIP_HaveAccessToItem(client, g_ItemID, bAccessByFlag))
	{
		PrintToConsole(client, "%t", "no access");
		return Plugin_Handled;
	}
	
	if (!bAccessByFlag)
	{
		x = VIP_GetFlags(client);
		if ((x & VCF_HOLIDAY) || (x & VCF_VIPFREE) || !(x & VCF_VIP))
		{
			PrintToConsole(client, "%t", "no access");
			return Plugin_Handled;
		}
	}
	
	decl String:email[150];
	GetCmdArgString(email, sizeof(email));
	if (TrimString(email)) StripQuotes(email);
		
	if (TrimString(email) < 5 || StrContains(email, "@") < 1 || StrContains(email, ".") < 1)
	{
		PrintToConsole(client, "sm_vipsteamprotect \"email\"");
		return Plugin_Handled;
	}
	
	decl String:steamid[STEAMID_LENGTH];
	if (!GetClientAuthId(client, AuthId_Steam2, steamid, sizeof(steamid)))
		return Plugin_Handled;

	g_Protect[client] = QUERY_NOT_COMPLITED;
	
	decl String:new_login[33];
	wS_GetRandomKey(new_login, sizeof(new_login), 32);

	decl String:new_pass [33];
	wS_GetRandomKey(new_pass,  sizeof(new_pass),  32);

	decl String:db_pass  [33];
	ConvertPassToMd5(new_pass, steamid, db_pass);

	new Handle:hPack		= CreateDataPack();
	WritePackCell(hPack,	GetClientUserId(client));
	WritePackString(hPack,	new_login);
	WritePackString(hPack,	new_pass);

	decl String:sDriver[16];
	SQL_ReadDriver(g_hSQL, sDriver, sizeof(sDriver));

	decl String:sInfo[512];
	FormatEx(sInfo, sizeof(sInfo), "INSERT %s INTO `vip_steam_protect_tab` (`steamid`, `email`, `vip_login`, `vip_pass`) VALUES ('%s', '%s', '%s', '%s')",
		!strcmp(sDriver, "mysql", false) ? "IGNORE" : "OR IGNORE", steamid, email, new_login, db_pass);
	SQL_TQuery(g_hSQL,		SQL_Insert, sInfo, hPack, DBPrio_High);
	
	return Plugin_Handled;
}

public SQL_Insert(Handle:hSQL, Handle:hResult, const String:sError[], any:hPack)
{
	ResetPack(hPack);
	new client = GetClientOfUserId(ReadPackCell(hPack));
	decl String:new_login[33];
	ReadPackString(hPack, new_login, sizeof(new_login));
	decl String:new_pass [33];
	ReadPackString(hPack, new_pass,  sizeof(new_pass));
	CloseHandle(hPack);

	if (client < 1)
		return;
	
	if (!hResult)
	{
		g_Protect[client] = NEED_QUERY;
		LogError(sError);
		if (client > 0) PrintToChat(client, sError);
		return;
	}

	if (SQL_GetAffectedRows(hResult) > 0)
	{
		g_Protect[client] = PROTECTED;
		decl String:sInfo[512];
		FormatEx(sInfo, sizeof(sInfo), "%T", "protect_enabled", client);
		if (GetEngineVersion() == Engine_CSGO) // Молодец csgo.. Без пробела показать цвет никак да?
		{
			PrintToChat(client, " \x04%s", sInfo);
			PrintToChat(client, " \x04setinfo \"%s\" \"%s\"", new_login, new_pass);
		}
		else
		{
			PrintToChat(client, "\x04%s", sInfo);
			PrintToChat(client, "\x04setinfo \"%s\" \"%s\"", new_login, new_pass);
		}
	}
	else
		g_Protect[client] = NEED_QUERY;
}

stock bool:SqlOn(client)
{
	if (!g_hSQL)
	{
		PrintToChat(client, "%t", "no sql connect");
		return false;
	}
	return true;
}

stock wS_GetRandomKey(String:key[], maxlength, key_symbols)
{
	static const String:s[][] = 
	{
		"1","2","3","4","5","6","7","8","9","0",
		"q","w","e","r","t","y","u","i","o","p","a","s","d","f","g","h","j","k","l","z","x","c","v","b","n","m",
		"Q","W","E","R","T","Y","U","I","O","P","A","S","D","F","G","H","J","K","L","Z","X","C","V","B","N","M"
	};
	key[0] = 0;
	for (new i = 1; i <= key_symbols; i++)
		Format(key, maxlength, "%s%s", key, s[GetRandomInt(0, 61)]);
}

stock ConvertPassToMd5(const String:pass[], const String:steamid[], String:md5_pass[])
{
	decl String:sInfo[256];
	FormatEx(sInfo, sizeof(sInfo), "%s%s%s", pass, steamid, MD5_SALT);
	HM_MD5(sInfo, md5_pass);
}